package com.om.entity.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author bmmx
 * @since 2024-03-06
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("diagnosis_version_info")
@ApiModel(value="DiagnosisVersionInfo对象", description="")
public class DiagnosisVersionInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "ID")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "品牌ID")
    private Integer brandId;
    @ApiModelProperty(value = "品牌名称")
    private String brandCode;
    @ApiModelProperty(value = "客户端编号")
    private String clientNumber;


    @ApiModelProperty(value = "密码代码")
    private String cipherCode;

    @ApiModelProperty(value = "客户端路径")
    private String clientPath;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
    private LocalDateTime createTime;

    @ApiModelProperty(value = "描述")
    private String description;

    @ApiModelProperty(value = "诊断程序版本英文名称")
    private String diagnosisEn;

    @ApiModelProperty(value = "诊断程序版本文件大小")
    private String diagnosisFileSize;

    @ApiModelProperty(value = "诊断程序版本名称")
    private String diagnosisName;

    @ApiModelProperty(value = "功能名")
    private String functionName;

    @ApiModelProperty(value = "英文描述")
    private String englishDescription;

    @ApiModelProperty(value = "诊断程序文件")
    private String file;

    @ApiModelProperty(value = "文件名")
    private String fileName;

    @ApiModelProperty(value = "lifecycle 0：测试版 1：正式版")
    private Integer lifecycle;

    @ApiModelProperty(value = "管理者ID")
    private Integer adminId;

    @ApiModelProperty(value = "MD5摘要")
    private String md5;

    @ApiModelProperty(value = "发布名称")
    private String releaseName;

    @ApiModelProperty(value = "发布时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
    private LocalDateTime releaseTime;

    @ApiModelProperty(value = "诊断程序下载链接")
    private String savePath;

    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
    private LocalDateTime updateTime;

    @ApiModelProperty(value = "版本号")
    private String versionNum;

    @ApiModelProperty(value = "状态")
    private Integer status;

    @ApiModelProperty(value = "管理员名称")
    private String username;

    @ApiModelProperty(value = "θ：强制更新  1：不强制")
    private Integer isUpdate;

}
